# Migration to TYPO3 9

Unfortunately TYPO3 fucked it completely up. There are several issues with translations afterwards that can only be
solved by doing manual work.

## Migrate Tags

All tags must be synchronized with the translated pages as pages_language_overlay was dropped and TYPO3 didn't handled this
properly. If you don't use tags, you are a lucky guy. If you used tags, you can now be lucky. Just execute the
following SQL.

```
# Hole alle Tags von Seiten, welche Übersetzungen haben mit zugehörigem Page-Record der Übersetzung
# UND synchronisiere die neuen Tags für die Übersetzungen
INSERT INTO sys_category_record_mm (uid_local, uid_foreign, tablenames, fieldname, sorting, sorting_foreign)
  SELECT sys_category_record_mm.uid_local, pages.uid, 'pages', 'tx_sgnews_tags', sys_category_record_mm.sorting, sys_category_record_mm.sorting_foreign FROM pages, sys_category_record_mm WHERE pages.l10n_parent IN (
    SELECT uid_foreign FROM sys_category_record_mm WHERE fieldname = 'tx_sgnews_tags'
  ) AND sys_category_record_mm.uid_foreign = pages.l10n_parent;
```

## Migrate Images

All images must be resynchronized in all translations as images must always be carefully translated now in ALL records
and not only pages. Unfortunately there is no automatic approach. You must do it on your own. To simplify the process,
you should use mass badge processing offered by TYPO3.

1) Open the list view
2) Open the news category
3) Click on the table and the search icon in the top bar and choose 3 levels
4) All news should be listed for the category (you can also do that for the overview page if all news are grouped below)
5) At the very bottom, choose the higlight and teaser image fields now.
6) Click on the edit icon at the table header for hightlight images
7) Synchronize all images with the provided button and save
8) Do that now also for the teaser images and ALL pagination pages as TYPO3 loads only one page after the other.
